c
c	read datastream concatenated data and compute returns
c
c	note: Ecuador has two entries in data.  Delete the first one (country 16)
c
	parameter (ninf=17,nob=16000,ncoun=82)
	real*4 dex(nob,ninf),ret(nob,ninf)
	character*12 names(ninf,2)
	character*15 cnames(ncoun)
	character*40 filename(5)
	integer icount(ninf),hcount(ninf),scount(ninf)
     &,fm(ncoun),fd(ncoun),fy(ncoun),mon(nob),day(nob),yr(nob)
     &,baseday,week,hol,dayno(nob),nret(ninf),iweek(nob)
     &,lm(ncoun),ld(ncoun),ly(ncoun),day1(ninf),dayl(ninf)
	data icount/ninf*0/,fm/ncoun*0/,icwrite/0/,nb/0/

c
c	Day #1 is December 31, 1964
c
	baseday=jdays(12,30,1964,week,hol)

	open(6,file='get daily returns.out',status='unknown')
	open(7,file='ds daily returns.dat',status='unknown'
     &,form='unformatted')
	open(5,file='get daily returns.in',status='old')
	read(5,510)filename
510	format(a40)
	read(5,520)cnames
520	format(a15)
	do 10 nc=1,5
	if(nc.lt.5)then
	ncin=ninf
	else
	ncin=ninf-2
	endif
	do 11 jj=1,ncin
	day1(jj)=0
	dayl(jj)=0
	nret(jj)=0
	icount(jj)=0
	hcount(jj)=0
	scount(jj)=0
	fm(jj)=0
	fd(jj)=0
	fy(jj)=0
	lm(jj)=0
	ld(jj)=0
	ly(jj)=0
	do 111 ii=1,nob
	ret(ii,jj)=-99.
111	continue
11	continue
	open(1,file=filename(nc),status='old')
	do 12 m=1,2
12	read(1,52)(names(k,m),k=1,ncin)
52	format(10x,17a12)
	nt=1
1	continue
	read(1,50,end=99)mon(nt),day(nt),yr(nt),(dex(nt,k),k=1,ncin)
	if(mon(nt).eq.0)go to 99
	if(nc.eq.1)then
	if(yr(nt).lt.25)then
	iyear=yr(nt)+2000
	else
	iyear=yr(nt)+1900
	endif
	iday=jdays(mon(nt),day(nt),iyear,week,hol)-baseday
	dayno(nt)=iday
	iweek(nt)=week
	endif
50	format(2x,i2,1x,i2,1x,i2,17g12.5)
	nt=nt+1
	go to 1
99	continue
	nt=nt-1
c
c	write calendar file after reading first data file
c
	if(iwrite.eq.0)then
	iwrite=1
	write(7)nt,(dayno(j),mon(j),day(j),yr(j),j=1,nt)
	endif
c
c	compute a return ONLY if observations are one day or three days apart
c	This excludes holidays and holiday weekends but preserves normal weekends
c
	do 20 k=1,ncin
	do 21 j=2,nt

	if(dex(j,k).eq.0.)go to 21
	if(fm(k).eq.0)then
	day1(k)=j
	fm(k)=mon(j)
	fd(k)=day(j)
	fy(k)=yr(j)
	endif
	dayl(k)=j
	lm(k)=mon(j)
	ld(k)=day(j)
	ly(k)=yr(j)
	do 121 m=1,3
	jlag=j-m
	if(jlag.le.0)go to 21
	if(dex(jlag,k).eq.0.)go to 121
	idyf=dayno(j)-dayno(jlag)
	if(idyf.eq.1.or.idyf.eq.3)then
	if(idyf.eq.3)then
	if(iweek(j).ne.2)go to 121
	endif
c
c	expunge suspected holidays
c
	if(dex(jlag,k).eq.dex(j,k))go to 121
	jlag1=jlag-1
	if(jlag1.ge.1)then
	if(dex(jlag,k).eq.dex(jlag1,k))go to 121
	endif
c
c	Here's an observation one or three days earlier; compute return
c
	ret(j,k)=alog(dex(j,k)/dex(jlag,k))
	nret(k)=nret(k)+1
	go to 21
	endif
121	continue
21	continue
20	continue

	write(6,51)nt,filename(nc)
51	format(/'Number of lines, ',i5,', in file: ',a40//
     &4x,'Country         Returns         Beginning           Ending')
	do 3 j=1,ncin
c
c	delete first occurrence of Ecuador
c
	if(nc.eq.1.and.j.eq.16)go to 3
	nb=nb+1
	if(fy(j).lt.20)then
	ipfy=2000+fy(j)
	else
	ipfy=1900+fy(j)
	endif
	if(ly(j).lt.20)then
	iply=2000+ly(j)
	else
	iply=1900+ly(j)
	endif
	write(6,53)nb,cnames(nb),nret(j),fm(j),fd(j),ipfy
     &,lm(j),ld(j),iply,day1(j),dayl(j)
53	format(i3,1x,a15,2x,i6,2(8x,i2,'/',i2,'/',i4,1x),2i6)
	lbeg=day1(j)
	lend=dayl(j)
	write(7)nb,cnames(nb),nret(j),lbeg,lend,(ret(l,j),l=lbeg,lend)
3	continue
	close(1)
10	continue
98	stop
	end


	function jdays(m,d,y,w,h)
c
c	Version debugged on 28 August 2006 agrees completely with Excel date function
c

c
c	INPUTS
	 
c		m: month
c		d: day
c		y: year (19xx or 20xx only)
c	OUTPUT
c		jdays: number of days from 1/1/1901 (day 1)
c		w=day of week, sun=1
c		h=1 if a holiday, otherwise 0
c
c	NB: All inputs and outputs must be integers
c
c       maximum (minium) date 12/31/2099 (1/1/1901)
c
c	Computes NYSE trading holidays based on the following
c
c	January 1, 						New Year's
c	Third Monday in January, 		MLK
c	Third Monday in February, 		Presidents'
c	Good Friday (variable)			Easter-2
c	Last Monday in May, 			Memorial
c	July 4, 						Independence
c	First Monday in September, 		Labor
c	Fourth Thursday in November, 	Thanksgiving
c	December 25, 					Christmas
c
      integer m,d,y,w,h,mon(12)
      data mon/0,31,59,90,120,151,181,212,243,273,304,334/
c	error return if date is not possible
        if(d.gt.31.or.m.gt.12
     &  .or.d.lt.1.or.m.lt.1.or.y.lt.1901.or.y.gt.2099)go to 99
        if(m.ne.2)go to 98
	if(d.gt.29)go to 99
        if(d.eq.29.and.mod(y,4).ne.0)go to 99
c
c	Note: 2000 WAS a leap year
c

98    jdy=y-1901
      i=d+mon(m)+365*jdy+jdy/4
2     if(mod(y,4).ne.0)go to 1
      if(m.lt.3)go to 1
      i=i+1
1     w=mod(i+1,7)+1
      jdays=i
c
c	check for holiday
c
	h=0
	h=jfixdy(m,d,w)
	if(h.eq.1)return
	if(w.eq.6.and.(m.eq.3.or.m.eq.4))h=jeaster(m,d,y,w)
	if(h.eq.1)return
	if(w.eq.5.and.m.eq.11)h=jthanks(m,d,w)
	if(h.eq.1)return
	if(w.eq.2)h=monhol(m,d,w)
      	return
99	jdays=-999999
	return
      	end
      	function jfixdy(m,d,wk)
c
c	New Year's, July 4, and Christmas or following Monday if weekend
c
	integer m,d,wk
	jfixdy=0
	if((m.eq.1.and.d.eq.1).or.(m.eq.12.and.d.eq.25).or.
     &	(m.eq.7.and.d.eq.4))then
		jfixdy=1
		return
	endif
	if(wk.ne.2)return
	if(m.eq.1.and.d.le.3)then
		jfixdy=1
		return
	endif
	if(m.eq.7.and.(d.gt.4.and.d.le.6))then
		jfixdy=1
		return
	endif
	if(m.eq.12.and.(d.gt.25.and.d.le.27))then
		jfixdy=1
	endif
	return
	end
	function jthanks(m,d,wk)
c
c	thanksgiving
c
	integer m,d,wk
	jthanks=0
	if(m.ne.11)return
	if(wk.ne.5)return
	if(d.ge.22.and.d.le.28)jthanks=1
	return
	end
	function monhol(m,d,wk)
c
c	Holidays regularly occurring on Monday
c
	integer m,d,wk
	monhol=0
	if(wk.ne.2)return
	if(m.ne.1.and.m.ne.2.and.m.ne.5.and.m.ne.9)return
	if((m.eq.1.or.m.eq.2).and.(d.ge.15.and.d.le.21))then
		monhol=1
		return
	endif
	if(m.eq.9.and.(d.ge.1.and.d.le.7))then
		monhol=1
		return
	endif
	if(m.eq.5.and.d.ge.25)monhol=1
		return
		end
	function jeaster(m,d,y,wk)
c
c	Good Friday (two days before Easter) using Carter's algorithm
c
	integer m,d,y,wk,b,e,q
	jeaster=0
	if(wk.ne.6)return
	if(m.ne.3.and.m.ne.4)return
	b=225-11*mod(y,19)
	dd=mod(b-21,30)+21
	if(dd.gt.48)dd=dd-1
	e=y+y/4+dd+1
	e=mod(e,7)
	q=dd+7-e
	if(m.eq.3.and.q.lt.32.and.d.eq.(q-2))then
		jeaster=1
		return
	endif
	if(q.gt.31)then
		q=q-31
		if(q.le.2.and.m.eq.3.and.(d.eq.30.or.d.eq.31))then
			jeaster=1
			return
		endif
		if(q.gt.2.and.m.eq.4.and.d.eq.(q-2))then
			jeaster=1
		endif
	endif
	return
	end

	