c
c	compute principal components every year starting in 1973
c	The data file was written by 'get daily returns.f' using DataStream
c	raw index files for 83 countries
c	Time zone depend only on which countries close before all others; these are
c	essentially in the Asian zone.  All other have lagged values included.
c
	parameter (nob=11247,ncoun=82,nyears=36,npc=75,ntmax=265,npcin=15)
      double precision sx,sy,sxy,sx2,sy2
	real*4 ret(nob,ncoun),x(265,ncoun),z(ntmax,npc,nyears)
	dimension pc(ntmax,npc,nyears),v(npc,npc,nyears),d(npc),a(npc,npc)
     &,cov(npc,npc),cpe(npc),wt(npc)
	real*8 sum,sumv,junk
	character*15 cnames(ncoun)
	character*40 outfile,pcfile
	integer mon(nob),day(nob),yr(nob),jbeg(ncoun),jend(ncoun)
     &,baseday,week,hol,dayno(nob),nret(ncoun),timezone(ncoun)
     &,begpc(nyears),endpc(nyears),decade(ncoun),tzkeep(ncoun)
     &,nobkeep(nyears),iseq(ntmax),jseq(ntmax,nyears)
     &,avail(ncoun,nyears),nobsk(nyears)
     &,icoun(ncoun,nyears),jcoun(ncoun,nyears),klkeep(nyears)
     &,ncinkeep(nyears)
	data decadu/1/,cutcoun/.8/,xmiss/-9999999./
     &,pc/715500*-9999999./,avail/2952*0/
      common /corres/sx,sy,sx2,sy2

c
c	Day #1 is December 31, 1964
c
	baseday=jdays(12,30,1964,week,hol)

	open(5,file='get pc.in',status='old')
	read(5,552)outfile
	read(5,552)pcfile
552	format(a40)
	open(6,file=outfile,status='unknown')
	open(7,file='ds daily returns.dat',status='old'
     &,form='unformatted')
	open(8,file=pcfile,status='unknown'
     &,form='unformatted')
	open(9,file='cumeigen.dat',status='unknown')
	open(3,file='countries and dates.prn',status='old')
	read(3,551)junk
551	format(a8)
	do 151 k=1,ncoun
	read(3,50)decade(k),timezone(k)
151	continue
50	format(14x,2i10)
	read(7)nt,(dayno(j),mon(j),day(j),yr(j),j=1,nt)
c
c	get beginning and ending sequence numbers for calendar years 1973-2007 inclusive
c
	now=1973
	iyear=1
	do 2 j=1,nt
	if(yr(j).lt.20)then
	kyear=yr(j)+2000
	else
	kyear=yr(j)+1900
	endif
	if (kyear.lt.now)go to 2
	begpc(iyear)=j
	now=now+1
	if(iyear.gt.1)endpc(iyear-1)=j-1
	iyear=iyear+1
	if(iyear.gt.nyears)go to 21
2	continue
21	j=0
	do 3 m=1,nyears-1
31	j=j+1
	if(begpc(m).eq.j)then
	nym=mon(j)
	nyd=day(j)
	if(yr(j).lt.20)then
	nyy=yr(j)+2000
	else
	nyy=yr(j)+1900
	endif
	jjbeg=j
	endif
	if(endpc(m).eq.j)then
	nyml=mon(j)
	nydl=day(j)
	if(yr(j).lt.20)then
	nyyl=yr(j)+2000
	else
	nyyl=yr(j)+1900
	endif
	jjend=j
	go to 32
	endif
	go to 31
32	myear=m+1972
	ntd=jjend-jjbeg+1
	write(6,530)myear,begpc(m),nym,nyd,nyy,endpc(m),nyml,nydl,nyyl,ntd
530	format(i4,' begins ',i5,i3,'/',i2,'/',i4,' and ends '
     &,i5,i3,'/',i2,'/',i4,', N: ',i3)
3	continue
c
c	note: daily returns are exclusively either one day or three days apart.
c	All holiday and suspected holiday observations are expunged in 'get daily returns.f'
c
	write(6,532)
532	format('   Country        In? LBEG  LEND  NRET')
	do 1 k=1,ncoun
	read(7)nb,cnames(k),nret(k),lbeg,lend,(ret(l,k),l=lbeg,lend)
	if(k.ne.nb)then
	write(6,599)k,nb
599	format('Sequence error in data file ',2i3)
	endif
	jbeg(k)=lbeg
	jend(k)=lend
c
c	eliminate this country from the analysis unless it has at least 200 valid
c	observations in each pair of years
c
	do 73 m=1,nyears-1
	nobsk(m)=0
73	continue
	do 71 m=1,nyears-1
	if(lbeg.gt.endpc(m))go to 71
	if(lend.lt.begpc(m))go to 71
	do 72 j=begpc(m),endpc(m)
	if(ret(j,k).lt.-90.)go to 72
	nobsk(m)=nobsk(m)+1
72	continue
71	continue
	do 74 m=1,nyears-1
	if(nobsk(m).ge.200)avail(k,m)=1
74	continue
	write(6,531)k,cnames(k),lbeg,lend,nret(k)
     &,(avail(k,m),m=1,nyears-1)
531	format(i2,1x,a15,3i6,35i2)


1	continue
c
c	now do principal components using available stocks plus three north american lags
c
	do 100 m=1,nyears-1
	myear=1972+m
	mbeg=begpc(m)
	mend=endpc(m)
	jobs=mend-mbeg+1
	ncin=0
	
	do 101 k=1,ncoun
	if(avail(k,m).eq.0)go to 101
	if(avail(k,m+1).eq.0.and.m.lt.(nyears-1))go to 101
	ncin=ncin+1
	tzkeep(ncin)=timezone(k)
	do 103 j=mbeg,mend
	jj=j-mbeg+1
	x(jj,ncin)=ret(j,k)
	iseq(jj)=j
103	continue
c
c	icoun keeps track of which country is included
c
	jcoun(ncin,m+1)=k
	icoun(ncin,m)=k
101	continue
c
c	add country index numbers for lagged observations
c
	kl=ncin
	do 206 kk=1,ncin
	if(tzkeep(kk).le.0)go to 206
	kl=kl+1
	icoun(kl,m)=icoun(kk,m)
	jcoun(kl,m+1)=jcoun(kk,m+1)
206	continue
c	if(myear.eq.1999.or.myear.eq.2006)then
c	write(6,587)myear,(icoun(klop,m),klop=1,kl)
c	write(6,587)myear,(jcoun(klop,m+1),klop=1,kl)
587	format(i4/(20i3))
c	endif
c
c	stocks for this year with at least 200 observations now in.  Count simultaneous obs.
c
	nobs=0
	do 104 j=2,jobs
	do 105 k=1,ncin
	if(x(j,k).lt.-90.)go to 104
c
c	now check lagged observations for north american countries
c
	if(tzkeep(k).gt.0)then
	if(x(j-1,k).lt.-90.)go to 104
	endif
105	continue
	nobs=nobs+1
	jseq(nobs,m)=iseq(j)
	kl=ncin
	do 106 k=1,ncin
	z(nobs,k,m)=x(j,k)
	if(tzkeep(k).eq.0)go to 106
	kl=kl+1
	z(nobs,kl,m)=x(j-1,k)
106	continue
104	continue
	myear=m+1972
	write(6,51)myear,ncin,kl,nobs
51	format(i4,', ncin: ',i3,', kl: ',i3,', nobs: ',i4)

	nobkeep(m)=nobs
	klkeep(m)=kl
	ncinkeep(m)=ncin

	do 36 j=1,kl
	do 33 k=j,kl
	cov(j,k)=nobs*covary(z(1,j,m),z(1,k,m),nobs,xmiss)
	cov(k,j)=cov(j,k)
33	continue
36	continue
	call jacobi(cov,kl,npc,d,v(1,1,m),nrot)
c
c	v contains the eigenvectors, which will be used to get
c	principal components
c
	call eigsrt(d,v(1,1,m),kl,npc)
	sum=0.d0
	do 34 j=1,kl
	sum=sum+d(j)
34	continue
	do 35 j=1,kl
	cpe(j)=100*(d(j)/sum)
	if(j.gt.1)cpe(j)=cpe(j)+cpe(j-1)
35	continue
	write(6,352)
	write(6,351)(cpe(j),j=1,kl)
	myear=m+1972
	write(9,355)myear,cpe
355	format(i4,30f7.2)
352	format('Cumulative Percentages of Eigenvalues')
351	format(10f8.3)
c	write(6,353)
353	format('First five eigenvector, 1-17 contemporaneous')
c	do 361 ll=1,30
c	write(6,354)ll,(v(ll,j,m),j=1,5)
c354	format(i2,1x,5g12.5)
c361	continue

100	continue
c
c	eigenvectors ready.  compute principal components for the subsequent year 
c
	do 200 m=2,nyears-1
	myear=m+1972
	nobs=nobkeep(m)
	kl=klkeep(m-1)
	kl0=klkeep(m)
	ncin=ncinkeep(m-1)
	ncin0=ncinkeep(m)
	do 216 k=1,kl
	nobsin=0
	do 219 j=1,nobs
	sum=0.d0
	do 2110 my=1,ncin
	myy=my
	kin1=icoun(my,m-1)
	do 2111 ky=1,ncin
	kin0=jcoun(ky,m)
	if(kin0.ne.kin1)go to 2111
	kmy=ky
	go to 2112
2111	continue
	sum=xmiss
	imiss=1
	go to 2113
2112	continue
	if(z(j,kmy,m).gt.-90.)then	
	sum=sum+z(j,kmy,m)*v(my,k,m-1)
	go to 2110
	else
	sum=xmiss
	imiss=2
	go to 2113
	endif
2110	continue

	do 3110 my=ncin+1,kl
	kin1=icoun(my,m-1)
	do 3111 ky=ncin0+1,kl0
	kin0=icoun(ky,m)
	if(kin0.ne.kin1)go to 3111
	kmy=ky
	go to 3112
3111	continue
	sum=xmiss
	go to 2113
	imiss=3
3112	continue
	if(z(j,kmy,m).gt.-90.)then	
	sum=sum+z(j,kmy,m)*v(my,k,m-1)
	go to 3110
	else
	sum=xmiss
	go to 2113
	imiss=4
	endif
3110	continue
	nobsin=nobsin+1
	go to 3114
2113	continue
c
c	observation missing
c
	write(6,589)j,imiss,k,myy,kmy,kin1,kin0
589	format(7i6)
3114	pc(j,k,m)=sum
219	continue
216	continue
	write(6,5212)myear,nobs,nobsin
5212	format(/'Year: ',i4,', NOBS: ',i3,', NOBSIN: ',i3)
	if(nobsin.le.5)go to 200
	do 2212 k=1,5
	do 2213 j=1,k
	cov(j,k)=covary(pc(1,j,m),pc(1,k,m),nobs,xmiss)/(sx2*sy2)
2213	continue
	write(6,252)k,(cov(j,k),j=1,k)
252	format(i2,(5f8.4))
2212	continue
	write(8)m,myear,nobs,(jseq(j,m),j=1,nobs)
     &,((pc(j,k,m),j=1,nobs),k=1,npcin)
	write(6,253)myear,nobs,jseq(1,m),jseq(nobs,m),pc(1,1,m)
     &,pc(nobs,1,m)
253	format(2i4,2i6,2g12.4)
200	continue


98	stop
	end


	function jdays(m,d,y,w,h)
c
c	Version debugged on 28 August 2006 agrees completely with Excel date function
c

c
c	INPUTS
	 
c		m: month
c		d: day
c		y: year (19xx or 20xx only)
c	OUTPUT
c		jdays: number of days from 1/1/1901 (day 1)
c		w=day of week, sun=1
c		h=1 if a holiday, otherwise 0
c
c	NB: All inputs and outputs must be integers
c
c       maximum (minium) date 12/31/2099 (1/1/1901)
c
c	Computes NYSE trading holidays based on the following
c
c	January 1, 						New Year's
c	Third Monday in January, 		MLK
c	Third Monday in February, 		Presidents'
c	Good Friday (variable)			Easter-2
c	Last Monday in May, 			Memorial
c	July 4, 						Independence
c	First Monday in September, 		Labor
c	Fourth Thursday in November, 	Thanksgiving
c	December 25, 					Christmas
c
      integer m,d,y,w,h,mon(12)
      data mon/0,31,59,90,120,151,181,212,243,273,304,334/
c	error return if date is not possible
        if(d.gt.31.or.m.gt.12
     &  .or.d.lt.1.or.m.lt.1.or.y.lt.1901.or.y.gt.2099)go to 99
        if(m.ne.2)go to 98
	if(d.gt.29)go to 99
        if(d.eq.29.and.mod(y,4).ne.0)go to 99
c
c	Note: 2000 WAS a leap year
c

98    jdy=y-1901
      i=d+mon(m)+365*jdy+jdy/4
2     if(mod(y,4).ne.0)go to 1
      if(m.lt.3)go to 1
      i=i+1
1     w=mod(i+1,7)+1
      jdays=i
c
c	check for holiday
c
	h=0
	h=jfixdy(m,d,w)
	if(h.eq.1)return
	if(w.eq.6.and.(m.eq.3.or.m.eq.4))h=jeaster(m,d,y,w)
	if(h.eq.1)return
	if(w.eq.5.and.m.eq.11)h=jthanks(m,d,w)
	if(h.eq.1)return
	if(w.eq.2)h=monhol(m,d,w)
      	return
99	jdays=-999999
	return
      	end
      	function jfixdy(m,d,wk)
c
c	New Year's, July 4, and Christmas or following Monday if weekend
c
	integer m,d,wk
	jfixdy=0
	if((m.eq.1.and.d.eq.1).or.(m.eq.12.and.d.eq.25).or.
     &	(m.eq.7.and.d.eq.4))then
		jfixdy=1
		return
	endif
	if(wk.ne.2)return
	if(m.eq.1.and.d.le.3)then
		jfixdy=1
		return
	endif
	if(m.eq.7.and.(d.gt.4.and.d.le.6))then
		jfixdy=1
		return
	endif
	if(m.eq.12.and.(d.gt.25.and.d.le.27))then
		jfixdy=1
	endif
	return
	end
	function jthanks(m,d,wk)
c
c	thanksgiving
c
	integer m,d,wk
	jthanks=0
	if(m.ne.11)return
	if(wk.ne.5)return
	if(d.ge.22.and.d.le.28)jthanks=1
	return
	end
	function monhol(m,d,wk)
c
c	Holidays regularly occurring on Monday
c
	integer m,d,wk
	monhol=0
	if(wk.ne.2)return
	if(m.ne.1.and.m.ne.2.and.m.ne.5.and.m.ne.9)return
	if((m.eq.1.or.m.eq.2).and.(d.ge.15.and.d.le.21))then
		monhol=1
		return
	endif
	if(m.eq.9.and.(d.ge.1.and.d.le.7))then
		monhol=1
		return
	endif
	if(m.eq.5.and.d.ge.25)monhol=1
		return
		end
	function jeaster(m,d,y,wk)
c
c	Good Friday (two days before Easter) using Carter's algorithm
c
	integer m,d,y,wk,b,e,q
	jeaster=0
	if(wk.ne.6)return
	if(m.ne.3.and.m.ne.4)return
	b=225-11*mod(y,19)
	dd=mod(b-21,30)+21
	if(dd.gt.48)dd=dd-1
	e=y+y/4+dd+1
	e=mod(e,7)
	q=dd+7-e
	if(m.eq.3.and.q.lt.32.and.d.eq.(q-2))then
		jeaster=1
		return
	endif
	if(q.gt.31)then
		q=q-31
		if(q.le.2.and.m.eq.3.and.(d.eq.30.or.d.eq.31))then
			jeaster=1
			return
		endif
		if(q.gt.2.and.m.eq.4.and.d.eq.(q-2))then
			jeaster=1
		endif
	endif
	return
	end



      SUBROUTINE eigsrt(d,v,n,np)
c
c	given the eigenvalues d and eigenvectors v from jacobi, this routine sorts
c	the eigenvalues into descending order, and rearranges the columns of v
c	correspondingly.  
c
      INTEGER n,np
      REAL d(np),v(np,np)
      INTEGER i,j,k
      REAL p
      do 13 i=1,n-1
        k=i
        p=d(i)
        do 11 j=i+1,n
          if(d(j).ge.p)then
            k=j
            p=d(j)
          endif
11      continue
        if(k.ne.i)then
          d(k)=d(i)
          d(i)=p
          do 12 j=1,n
            p=v(j,i)
            v(j,i)=v(j,k)
            v(j,k)=p
12        continue
        endif
13    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 21[.

	function covary(x,y,n,xmiss)
c
c  means, variances, and covariances between series x and y
c  any value below xmiss is missing and is not used in the calculation
c
      dimension x(1),y(1)
      double precision sx,sy,sxy,sx2,sy2
      common /corres/sx,sy,sx2,sy2
      sx=0.d0
      sy=0.d0
      sxy=0.d0
      sx2=0.d0
      sy2=0.d0
	nobs=0
      do 1 l=1,n
	if(x(l).le.xmiss.or.y(l).le.xmiss)go to 1
	nobs=nobs+1
      sx=sx+x(l)
      sx2=sx2+x(l)**2
      sy=sy+y(l)
      sy2=sy2+y(l)**2
      sxy=sxy+x(l)*y(l)
1     continue
      sx=sx/nobs
      sy=sy/nobs
      sx2=dsqrt(sx2/nobs-sx**2)
      sy2=dsqrt(sy2/nobs-sy**2)
      sxy=sxy/nobs-sx*sy
      covary=sxy
      return
      end


      SUBROUTINE jacobi(a,n,np,d,v,nrot)
c
c	computes all eigenvalues and eigenvectors of a real symmetric matrix a
c	whose size is n, stored in an np X np array.  On output, elements above the
c	diagonal of a are destroyed.  d returns the eigenvalues of a in its first n elements.
c	v is a matrix with the same logical and physical dimensions as a, whose columns 
c	contain, on output, the normalized eigenvectors of a.  nrot retuns the number of
c	jacobi rotations that were required.
c
      INTEGER n,np,nrot,NMAX
      REAL a(np,np),d(np),v(np,np)
      PARAMETER (NMAX=500)
      INTEGER i,ip,iq,j
      REAL c,g,h,s,sm,t,tau,theta,tresh,b(NMAX),z(NMAX)
      do 12 ip=1,n
        do 11 iq=1,n
          v(ip,iq)=0.
11      continue
        v(ip,ip)=1.
12    continue
      do 13 ip=1,n
        b(ip)=a(ip,ip)
        d(ip)=b(ip)
        z(ip)=0.
13    continue
      nrot=0
      do 24 i=1,50
        sm=0.
        do 15 ip=1,n-1
          do 14 iq=ip+1,n
            sm=sm+abs(a(ip,iq))
14        continue
15      continue
        if(sm.eq.0.)return
        if(i.lt.4)then
          tresh=0.2*sm/n**2
        else
          tresh=0.
        endif
        do 22 ip=1,n-1
          do 21 iq=ip+1,n
            g=100.*abs(a(ip,iq))
            if((i.gt.4).and.(abs(d(ip))+
     *g.eq.abs(d(ip))).and.(abs(d(iq))+g.eq.abs(d(iq))))then
              a(ip,iq)=0.
            else if(abs(a(ip,iq)).gt.tresh)then
              h=d(iq)-d(ip)
              if(abs(h)+g.eq.abs(h))then
                t=a(ip,iq)/h
              else
                theta=0.5*h/a(ip,iq)
                t=1./(abs(theta)+sqrt(1.+theta**2))
                if(theta.lt.0.)t=-t
              endif
              c=1./sqrt(1+t**2)
              s=t*c
              tau=s/(1.+c)
              h=t*a(ip,iq)
              z(ip)=z(ip)-h
              z(iq)=z(iq)+h
              d(ip)=d(ip)-h
              d(iq)=d(iq)+h
              a(ip,iq)=0.
              do 16 j=1,ip-1
                g=a(j,ip)
                h=a(j,iq)
                a(j,ip)=g-s*(h+g*tau)
                a(j,iq)=h+s*(g-h*tau)
16            continue
              do 17 j=ip+1,iq-1
                g=a(ip,j)
                h=a(j,iq)
                a(ip,j)=g-s*(h+g*tau)
                a(j,iq)=h+s*(g-h*tau)
17            continue
              do 18 j=iq+1,n
                g=a(ip,j)
                h=a(iq,j)
                a(ip,j)=g-s*(h+g*tau)
                a(iq,j)=h+s*(g-h*tau)
18            continue
              do 19 j=1,n
                g=v(j,ip)
                h=v(j,iq)
                v(j,ip)=g-s*(h+g*tau)
                v(j,iq)=h+s*(g-h*tau)
19            continue
              nrot=nrot+1
            endif
21        continue
22      continue
        do 23 ip=1,n
          b(ip)=b(ip)+z(ip)
          d(ip)=b(ip)
          z(ip)=0.
23      continue
24    continue
      pause 'too many iterations in jacobi'
      return
      END	